#include "mex.h"
#include <stdlib.h>

/*
 * plhs[0] = *selections
 * 
 * prhs[0] = *counts
 * prhs[1] = samples
 *
 */

#define drand() (rand()/((double)RAND_MAX + 1))

void mexFunction (int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) 
{

  double samples;
  double *counts;
  double randNum;
  double currProb;
  int N;
  int i;
  int selection;
  int sumCounts;
  double *selections;
  

  N = mxGetN(prhs[0]);
  
  counts    = mxGetPr(prhs[0]);
  samples = mxGetScalar(prhs[1]);
  plhs[0] = mxCreateDoubleMatrix(1,N,mxREAL);
  selections  = mxGetPr(plhs[0]);
  
  sumCounts = 0;      

  for (i = 0; i < N; i++) {
    sumCounts = sumCounts + counts[i];
    selections[i] = 0;
  }

  for (i = 0; i < samples; i++) {
    randNum = drand();

    while (randNum == 0)
    {
      randNum = drand();
    } 

    currProb = counts[0] / sumCounts;
    selection = 0;


    while (randNum > currProb) {
      selection = selection + 1;
      currProb = currProb + (counts[selection] / sumCounts);
    }

    
    selections[selection] = selections[selection] + 1;


    counts[selection] = counts[selection] - 1;
    sumCounts = sumCounts - 1;


  }

}
